#ifndef HASTAB_INCLUDED 
#define HASTAB_INCLUDED

#define EXIST		0
#define SUCCESS		1
#define BUCKSIZE        10240

#define MAX_GROUPS	32  // max number of groups
#define MAX_NODES	512 // max number of nodes

typedef enum { LOG_GEN, LOG_RECV, LOG_MGEN, LOG_MRECV } logtype;
typedef enum { FALSE, TRUE } bool ;

struct entry {
   char   *str ;
   int    len;
   float  time ;
   struct entry *link ;
   int    flag;
} ;

struct grp_entry {
   int    gid; // group id
   int    nid; // node id
   float  time ;
   struct grp_entry *link ;
} ;

struct entry *lookup ( logtype lt, const char *str, float time, bool insert ) ;
struct grp_entry *grp_lookup ( const int gid, const int nid, float time, bool insert );
void print_all( logtype lt);
void print_stats( bool verbose );
void print_mstats( bool verbose );
void init();

#endif
